<html>
<head>
<title>OgreShaderPrerequisites.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderPrerequisites.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderPrerequisites_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef __ShaderPrerequisites_H__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define __ShaderPrerequisites_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre 
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00037"></a>00037 <span class="keyword">class </span>Technique;
<a name="l00038"></a>00038 <span class="keyword">class </span>Pass;
<a name="l00039"></a>00039 <span class="keyword">class </span>Renderable;
<a name="l00040"></a>00040 <span class="keyword">class </span>Viewport;
<a name="l00041"></a>00041 <span class="keyword">class </span>RenderObjectListener;
<a name="l00042"></a>00042 <span class="keyword">class </span>TextureUnitState;
<a name="l00043"></a>00043 <span class="keyword">class </span>Frustum;
<a name="l00044"></a>00044 <span class="keyword">class </span>ScriptTranslator;
<a name="l00045"></a>00045 <span class="keyword">class </span>ScriptCompiler;
<a name="l00046"></a>00046 <span class="keyword">class </span>PropertyAbstractNode;
<a name="l00047"></a><a class="code" href="namespaceOgre.html#a3f7035c5ce4caa67a610946c00e442d0">00047</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>  <a class="code" href="namespaceOgre.html#a3f7035c5ce4caa67a610946c00e442d0">RTShaderSystemAlloc</a>;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="keyword">namespace </span>RTShader 
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 
<a name="l00055"></a>00055 <span class="keyword">class </span>RenderState;
<a name="l00056"></a>00056 <span class="keyword">class </span>TargetRenderState;
<a name="l00057"></a>00057 <span class="keyword">class </span>SubRenderState;
<a name="l00058"></a>00058 <span class="keyword">class </span>SubRenderStateAccessor;
<a name="l00059"></a>00059 <span class="keyword">class </span>SubRenderStateFactory;
<a name="l00060"></a>00060 <span class="keyword">class </span>ProgramManager;
<a name="l00061"></a>00061 <span class="keyword">class </span>Program;
<a name="l00062"></a>00062 <span class="keyword">class </span>ProgramProcessor;
<a name="l00063"></a>00063 <span class="keyword">class </span>ProgramSet;
<a name="l00064"></a>00064 <span class="keyword">class </span>RenderState;
<a name="l00065"></a>00065 <span class="keyword">class </span>Parameter;
<a name="l00066"></a>00066 <span class="keyword">class </span>Function;
<a name="l00067"></a>00067 <span class="keyword">class </span>FFPRenderStateBuilder;
<a name="l00068"></a>00068 <span class="keyword">class </span>ShaderGenerator;
<a name="l00069"></a>00069 <span class="keyword">class </span>SGMaterialSerializerListener;
<a name="l00070"></a>00070 <span class="keyword">class </span>ProgramWriterFactory;
<a name="l00071"></a>00071 <span class="keyword">class </span>ProgramWriterManager;
<a name="l00072"></a>00072 
<a name="l00074"></a>00074 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00075"></a><a class="code" href="namespaceOgre_1_1RTShader.html#a54beb4e7e46937267d54e977a0146683">00075</a> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a54beb4e7e46937267d54e977a0146683" title="Utility function with same style as boost::hash_combine.">sh_hash_combine</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&amp; seed, T <span class="keyword">const</span>&amp; v)
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077     seed ^= <a class="code" href="group__General.html#gad838a1c9fb47071ba019701841b4cf10" title="Fast general hashing algorithm.">FastHash</a>((<span class="keyword">const</span> <span class="keywordtype">char</span>*)&amp;v, <span class="keyword">sizeof</span>(T)) + 0x9e3779b9 + (seed&lt;&lt;6) + (seed&gt;&gt;2);
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="comment">// Vertex shader output parameters compact policy.</span>
<a name="l00081"></a><a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355">00081</a> <span class="keyword">enum</span> <a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355">VSOutputCompactPolicy</a>
<a name="l00082"></a>00082 {   
<a name="l00083"></a><a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355a8cfbf169adc68d505a72c272dce91f2c">00083</a>     <a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355a8cfbf169adc68d505a72c272dce91f2c">VSOCP_LOW</a>       = 0,        <span class="comment">// VS Outputs will be compacted just in case the maximum slot count exceeded.</span>
<a name="l00084"></a><a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355ae8945142e897f91a533021242ce30313">00084</a>     <a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355ae8945142e897f91a533021242ce30313">VSOCP_MEDIUM</a>    = 1,        <span class="comment">// VS Outputs will be compacted always without parameter splits.</span>
<a name="l00085"></a><a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355af47ac7ffe0e82bd495a51205c2132aa4">00085</a>     <a class="code" href="namespaceOgre_1_1RTShader.html#ab0694782a83ac342574ac3cf1e053355af47ac7ffe0e82bd495a51205c2132aa4">VSOCP_HIGH</a>      = 2         <span class="comment">// VS Outputs will be compacted always including parameter splits.</span>
<a name="l00086"></a>00086 };
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">00088</a> <span class="keyword">enum</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a>
<a name="l00089"></a>00089 {
<a name="l00090"></a><a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1ab979c94e41c61d62d15f4771c5202e3c">00090</a>     <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1ab979c94e41c61d62d15f4771c5202e3c">ST_LINEAR</a>,
<a name="l00091"></a><a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1a08c0d76a7a8df2b6a839749c5be6c1af">00091</a>     <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1a08c0d76a7a8df2b6a839749c5be6c1af">ST_DUAL_QUATERNION</a>
<a name="l00092"></a>00092 };
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">#   if defined( OGRE_STATIC_LIB )</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">#       define _OgreRTSSExport</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">#       if defined( OgreRTShaderSystem_EXPORTS )</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="preprocessor">#           define _OgreRTSSExport __declspec( dllexport )</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">#       else</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#           if defined( __MINGW32__ )</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span><span class="preprocessor">#               define _OgreRTSSExport</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span><span class="preprocessor">#           else</span>
<a name="l00108"></a><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">00108</a> <span class="preprocessor"></span><span class="preprocessor">#               define _OgreRTSSExport __declspec( dllimport )</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">#           endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#elif defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#   define _OgreRTSSExport __attribute__ ((visibility(&quot;default&quot;)))</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">#   define _OgreRTSSExport</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">#endif </span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
